﻿using Microsoft.AspNetCore.Mvc.Formatters;

namespace SimpleFileServer.Formatters
{
    public class StreamInputFormatter : IInputFormatter
    {
        public bool CanRead(InputFormatterContext context) => context.ModelType == typeof(Stream);


        public async Task<InputFormatterResult> ReadAsync(InputFormatterContext context)
        {
            if (context == null)
            {
                throw new ArgumentNullException(nameof(context));
            }

            // enable stream rewind or you won't be able to read the file in the controller   
            var req = context.HttpContext.Request;

            var memoryStream = new MemoryStream();
            await context.HttpContext.Request.Body.CopyToAsync(memoryStream);
            return await InputFormatterResult.SuccessAsync(memoryStream);
        }
    }
}
