﻿namespace SimpleFileServer.Models
{
    /// <summary>
    /// Role of a user in the system
    /// </summary>
    public class Role
    {
        /// <summary>
        /// Role for uploads
        /// </summary>
        public static readonly Role Upload = new("upload");

        /// <summary>
        /// Role for downloads
        /// </summary>
        public static readonly Role Download = new("download");

        /// <summary>
        /// Role for listing directory contents
        /// </summary>
        public static readonly Role List = new("list");

        /// <summary>
        /// The name of the role
        /// </summary>
        public string Name { get; set; }

        private Role(string name)
        {
            Name = name;
        }
    }
}
