﻿namespace SimpleFileServer.Models
{
    /// <summary>
    /// User of the service
    /// </summary>
    public class ServiceUser
    {
        /// <summary>
        /// User ID
        /// </summary>
        public int Id { get; set; }

        /// <summary>
        /// Username
        /// </summary>
        public string Username { get; set; }

        /// <summary>
        /// User's password
        /// </summary>
        public string Password { get; set; }

        /// <summary>
        /// Roles the user has
        /// </summary>
        public List<Role> Roles { get; set; }


        /// <summary>
        /// Create a new user with empty roles
        /// </summary>
        /// <param name="id"></param>
        /// <param name="username"></param>
        /// <param name="password"></param>
        public ServiceUser(int id, string username, string password)
            : this(id, username, password, new List<Role>())
        { }


        /// <summary>
        /// Create a new user with roles
        /// </summary>
        /// <param name="id"></param>
        /// <param name="username"></param>
        /// <param name="password"></param>
        /// <param name="roles"></param>
        public ServiceUser(int id, string username, string password, List<Role> roles)
        {
            Id = id;
            Username = username;
            Password = password;
            Roles = roles;
        }
    }
}
